#ifndef dud4_playertask_hh
#define dud4_playertask_hh

#include "task.hh"
#include "events.hh"

class playertask : public task
{
	int sock;
	string input;                   // Current input line
	mutable char lineterm;          // Line terminator char (autodetect)
	mutable unsigned char got_iac;  // Telnet option
	
	class playerdata *data;
	
	friend class playerdata;
	
public:
	playertask(int s);
	~playertask();
	virtual void echo(const string &s, bool addcr = true) const;
	virtual bool tick();
	virtual void operator += (const event &ev);
};

#endif
