#include "taskmanager.hh"

void taskmanager::insert(task *n)
{
	tasks.push_back(n);
}

bool taskmanager::tick()
{
    list<task *>::iterator i, j;
    for(i=tasks.begin(); i!=tasks.end(); i = j)
    {
    	j = i;
    	++j;
    	if(!(*i)->tick())
    	{
    		delete *i;
    		tasks.erase(i);
    	}
    }
    return alive;
}

taskmanager::~taskmanager()
{
	list<task *>::iterator i;
	
	cout << "Killing all tasks...\n";
	
	for(i=tasks.begin(); i!=tasks.end(); ++i)
		delete *i;
		
	cout << "Taskmanager going down.\n";
}

void taskmanager::operator += (const class event &ev)
{
	list<task *>::iterator i;
	for(i=tasks.begin(); i!=tasks.end(); ++i)
		**i += ev;
}
