#ifndef dud4_taskmanager_hh
#define dud4_taskmanager_hh

#include "task.hh"

#include <list>

extern class taskmanager : public task
{
	list<task *> tasks;
public:
	bool alive;
public:
	taskmanager() : alive(true) { }
	~taskmanager();
	void insert(task *n);
	virtual bool tick();
	void operator += (const class event &ev);
	inline unsigned numtasks() const { return tasks.size(); }
} taskmanager;

#endif
